#ifndef _SHOW_H_
#define _SHOW_H_
#include "am.h"

/* Preferred float length */
#define FLOAT_LENGTH 8

/*
 * Print the value into the string buffer, bounded by length lim
 * Returns the number of characters wrote, or -1 if buffer exceeded.
 * Does not null terminate the string.
 * Does not rely on sprintf or friends.
 *
 * Prints values as per the spec:
 * - no escaping of chars/strings
 * - tuple/vectors are flattened.
 * - int, float, boolean are followed by a space.
 */

int32 textValue(char *buffer, int32 lim, HEAP v, const char *type);

#endif /*_SHOW_H_*/


