#ifndef _ops_h_
#define _ops_h_

typedef enum {
 OP_MKINT = 0,				/* heap */
 OP_MKFLOAT,				/* heap */
 OP_MKSTRING,				/* heap */
 OP_MKCHAR,					/* heap */
 OP_MKCON,					/* heap */
 OP_MKTUPLE,				/* heap */
 OP_MKNONE,					/* heap */
 OP_PUSHVAR,				/* stack */
 OP_PUSH,					/* stack */
 OP_POP,					/* stack */
 OP_SLIDE,					/* stack */
 OP_COPY,					/* stack */
 OP_COPYARG,				/* stack */
 OP_CREATEFRAME,			/* stack */
 OP_CALL,					/* control */
 OP_CALLPRIM,				/* control */
 OP_RETURN,					/* control */
 OP_GOTO,					/* control */
 OP_IF,						/* control */
 OP_COPYINPUT,				/* ----> OP_COPYALLINPUTS */
 OP_WRITE,					/* init+wire */
 OP_CONSUME,				/* ----> OP_CONSUMESET */
 OP_MAYBECONSUME,			/* ----> OP_CONSUMESET */
 OP_SCHEDULE,				/* init */
 OP_REORDER,				/* ----> CHECKOUTPUTSREORDER ----> CHECKOUTPUTS */
 OP_MATCHRULE,				/* match */
 OP_MATCHAVAILABLE,			/* ----> OP_AVAILSET */
 OP_MATCHNONE,				/* match */
 OP_MATCHINT,				/* match */
 OP_MATCHFLOAT,				/* match */
 OP_MATCHSTRING,			/* match */
 OP_MATCHCHAR,				/* match */
 OP_MATCHCON,				/* match */
 OP_MATCHTUPLE,				/* match */
 OP_MATCHVAR,				/* match */
 OP_MATCHANY,				/* match */
 OP_UNPACK,					/* stack */
 OP_MKBOOL,					/* heap */
 OP_MATCHBOOL,				/* match */
 OP_INPUT,					/* ----> deprecated */
 OP_OUTPUT,					/* ----> deprecated */
 OP_NOOP,					/* extra */
 OP_PUSHVARF,				/* stack */
 OP_STARTMATCHES,			/* match */
 OP_MAKEVAR,				/* stack */
 OP_CHECKOUTPUTS,			/* wires */
 OP_MKVECTOR,				/* heap */
 OP_MATCHVECTOR,			/* match */
 OP_RAISE,					/* control */
 OP_MATCHEXN,				/* match */
 OP_MATCHASVAR,				/* match */
 OP_CALLVAR,
 OP_CALLVARF,
 OP_MKFUN,					/* heap */
 OP_SLIDEVAR,
 OP_SLIDEVARF,
 OP_AP,
 OP_CALLF,
 OP_WITHIN,					/* control */
 OP_DONEWITHIN,				/* control */
 OP_RAISEWITHIN,			/* ----> deprecated */
 OP_WITHINSPACE,			/* ----> WITHINSTACK/HEAP */
 OP_DONEWITHINSPACE,		/* ----> DONEWITHINSTACK/HEAP */
 OP_STARTPROFILE,
 OP_ENDPROFILE,
 OP_STARTTIME,
 OP_ENDTIME,
 OP_STARTVERIFY,
 OP_ENDVERIFY,
 OP_CALLEXTERN,				/* control */
 OP_TAILCALL,				/* control */
 OP_MATCHEDRULE,			/* match */
 OP_LABEL,					/* psuedo-op (also used to generate box/init entry code) */
 OP_FUNCTION,				/* psuedo-op */
 OP_BOX,					/* psuedo-op */
 OP_RULE,					/* psuedo-op */
 OP_REQUIRE,				/* psuedo-op */
 OP_WIRE,					/* psuedo-op */
 OP_STREAM,					/* psuedo-op */
 OP_INTERRUPT,				/* psuedo-op */
 OP_MMAP,					/* psuedo-op */
 
 OP_UNION,
 OP_UNIONC,

  /* extensions */
 OP_CONSUMESET,				/* wires */
 OP_COPYALLINPUTS,			/* wires */
 OP_CHECKOUTPUTSREORDER,	/* ----> CHECKOUTPUTS */
 OP_AVAILSET,				/* wires, match */
 OP_WITHINSTACK,			/* control */
 OP_DONEWITHINSTACK,		/* control */
 OP_WITHINHEAP,				/* control */
 OP_DONEWITHINHEAP,			/* control */
 OP_MATCHCONSTANTSTRING,
 OP_GETCONSTANT,
 OP_MKCONSTANT,
 OP_COMMENT,
 
 OP_UNKNOWN
} opcode_e;

opcode_e findOp(char *prim);
const char *opName(opcode_e);

#endif /*_ops_h_*/


